#Originally by JF but this version AlexM tweaked and rewritten:)
#
# 2010-12-06 <jim.foltz@gmail.com>
#   * Group names are saved to a file for persistence.

require 'sketchup'

module JF
    def self.named_group
	max_names = 20
	pf = File.expand_path(File.dirname(__FILE__))
	names_file = File.join(pf, "makeNamedGroup_names.txt")
	if @grNames.class != Array
	    @grNames = []
	    if File.exists?(names_file)
		IO.foreach(names_file) do |line|
		    line.strip!
		    @grNames << line unless line.empty?
		end
	    end
	end
	model = Sketchup.active_model
	selection = model.selection
	return if selection.empty?
	Sketchup.set_status_text "OK = Create named group; Cancel = Create unnamed group" 
	prompts = @grNames.size == 0 ? ["Group Name:"] : ["Group Name:", ""]
	ret = UI.inputbox(prompts, [@grNames[0]], [@grNames.join("|")], "New Group")
	return if ret == false
	#return if ret[0] == ""
	Sketchup.set_status_text "Ready"
	grp = model.active_entities.add_group selection
	selection.clear
	selection.add grp
	ret[1] = ret[0] unless ret[1]
	ret[1] == "" ? @grNames.unshift(ret[0]).uniq! : @grNames.unshift(ret[1]).uniq!
	@grNames = @grNames[0...max_names]
	grp.name = @grNames[0]
	File.open(names_file, "w") do |f|
	    @grNames.each do |name|
		f.puts(name)
	    end
	end
    end
end

file_name = File.basename(__FILE__)
unless file_loaded?(file_name)
    cmd = UI::Command.new("Make Named Group") { JF.named_group }
    cmd.status_bar_text = "Create a named group from the selected geometry"
    cmd.tooltip = "Create a named group"
    cmd.set_validation_proc {Sketchup.active_model.selection.empty? ? MF_GRAYED : MF_ENABLED}
    UI.menu("Edit").add_item(cmd)
    UI.add_context_menu_handler do |mnu|
	mnu.add_item(cmd) unless Sketchup.active_model.selection.empty?
    end
    file_loaded file_name
end
